package Fumarole_siege {
//-------------------------------------------------------------------------------------------- begin Fumarole_siege package ---***---

//------------------------------------------------------------------------------------------------ SiegeGame::gameOver ---

function SiegeGame::gameOver( %game )
{	
   deactivatePackage(Fumarole_siege);
   error("SiegeGame::gameOver - deacitavting Fumarole_Siege package");
   SiegeGame::gameOver( %game );
}

//----------------------------------------------------------------------------------------- SiegeGame::missionLoadDone ---
function SiegeGame::missionLoadDone(%game)
{	
   //set the custom spawn weights
   nameToId("MainBaseSpawn1").sphereWeight = 100;
   nameToId("MainBaseSpawn2").sphereWeight = 100;
   nameToId("MainBaseSpawn3").sphereWeight = 100;

   Parent::missionLoadDone(%game);

   //call after parent
   Game.defenseTeam = Game.offenseTeam == 1 ? 2 : 1;
}

//---------------------------------------------------------------------------------------------- Generator::onDisabled ---

function Generator::onDisabled(%data, %obj)
{
   Parent::onDisabled(%data, %obj);

   //reserve generator
   if (%obj == nameToId("ReserveGenerator"))
   {
      %count = ClientGroup.getCount();
      for (%i = 0; %i < %count; %i++)
      {
         %client = ClientGroup.getObject(%i);
         if( %client.team == %obj.team )
         {
            if (nameToId("MainBase").powerCount == 0)
            { 
               messageClient(%client, 'MsgClient', '~wfx/misc/red_alert.wav');
               bottomPrint(%client, "<color:FF0000>\RED ALERT - Objective Switch Exposed - RED ALERT", 5, 2);
            }
            else
            {
               messageClient(%client, 'MsgClient', '~wfx/misc/red_alert_short.wav');
               bottomPrint(%client, "<color:FF5500>\ALERT - Reserve Generator Destroyed - ALERT", 3, 2);
            }
         }
         else if (%client.team == Game.offenseTeam)
         {
            if (nameToId("MainBase").powerCount == 0)
            {
               messageClient(%client, 'MsgClient', '~wfx/Bonuses/Nouns/general.wav');
               bottomPrint(%client, "<color:8BBD03>\- Objective Switch Exposed -", 5, 2);
            }
            else
            {
               messageClient(%client, 'MsgClient', '~wfx/Bonuses/Nouns/major.wav');
               bottomPrint(%client, "<color:8BBD03>\- Reserve Generator Destroyed -", 3, 2);
            }
         }
      }
   }

   //main generators
   if (%obj == nameToId("MainGen1") || %obj ==  nameToId("MainGen2"))
   {
      if (nameToId("MainBase").powerCount == 0)
      {
      
         //if the switch generator was destroyed	
         %count = ClientGroup.getCount();
         for (%i = 0; %i < %count; %i++)
         {
            %client = ClientGroup.getObject(%i);
            if( %client.team == %obj.team )
            {
               if (nameToId("ReserveGroup").powerCount == 0)
               { 
                  messageClient(%client, 'MsgClient', '~wfx/misc/red_alert.wav');
                  bottomPrint(%client, "<color:FF0000>\RED ALERT - Objective Switch Exposed - RED ALERT", 5, 2);
               }
               else
               {
                  messageClient(%client, 'MsgClient', '~wfx/misc/red_alert_short.wav');
                  bottomPrint(%client, "<color:FF5500>\ALERT - Main Gens Destroyed: Emergency Spawnsphere Activated - ALERT", 3, 2);
               }
            }
            else if (%client.team == Game.offenseTeam)
            {
               if (nameToId("ReserveGroup").powerCount == 0)
               {
                  messageClient(%client, 'MsgClient', '~wfx/Bonuses/Nouns/general.wav');
                  bottomPrint(%client, "<color:8BBD03>\- Objective Switch Exposed -", 5, 2);
               }
               else
               {
                  messageClient(%client, 'MsgClient', '~wfx/Bonuses/Nouns/major.wav');
                  bottomPrint(%client, "<color:8BBD03>\- Main Generators Destroyed -", 3, 2);
               }
            }
         }

         //set the custom spawn weights
         nameToId("MainBaseSpawn3").sphereWeight = 100;
         nameToId("MainBaseSpawn1").sphereWeight = 0;
         nameToId("MainBaseSpawn2").sphereWeight = 0;
      }
   }

   //solar panels
   if (%obj == nameToId("NorthEntranceSP") && nameToId("ReserveGroup").powerCount > 0)
   {
      %count = ClientGroup.getCount();
      for (%i = 0; %i < %count; %i++)
      {
         %client = ClientGroup.getObject(%i);
         if( %client.team == %obj.team )
         {
            messageClient(%client, 'MsgClient', '~wfx/misc/red_alert_short.wav');
            bottomPrint(%client, "<color:FFFF00>\WARNING - Entrance Force Field Compromised - WARNING", 2, 2);
         }
         else if (%client.team == Game.offenseTeam)
         {
            messageClient(%client, 'MsgClient', '~wfx/Bonuses/Nouns/captain.wav');
            bottomPrint(%client, "<color:8BBD03>\- Entrance Force Field Compromised -", 2, 2);
         }
      }
   }
   if (%obj ==  nameToId("EastEntranceSP") && nameToId("ReserveGroup").powerCount > 0)
   {
      %count = ClientGroup.getCount();
      for (%i = 0; %i < %count; %i++)
      {
         %client = ClientGroup.getObject(%i);
         if( %client.team == %obj.team )
         {
            messageClient(%client, 'MsgClient', '~wfx/misc/red_alert_short.wav');
            bottomPrint(%client, "<color:FFFF00>\WARNING - Entrance Force Field Compromised - WARNING", 2, 2);
         }
         else if (%client.team == Game.offenseTeam)
         {
            messageClient(%client, 'MsgClient', '~wfx/Bonuses/Nouns/captain.wav');
            bottomPrint(%client, "<color:8BBD03>\- Entrance Force Field Compromised -", 2, 2);
         }
      }
   }
   if (%obj == nameToId("WestEntranceSP") && nameToId("ReserveGroup").powerCount > 0)
   {
      %count = ClientGroup.getCount();
      for (%i = 0; %i < %count; %i++)
      {
         %client = ClientGroup.getObject(%i);
         if( %client.team == %obj.team )
         {
            messageClient(%client, 'MsgClient', '~wfx/misc/red_alert_short.wav');
            bottomPrint(%client, "<color:FFFF00>\WARNING - Entrance Force Field Compromised - WARNING", 2, 2);
         }
         else if (%client.team == Game.offenseTeam)
         {
            messageClient(%client, 'MsgClient', '~wfx/Bonuses/Nouns/captain.wav');
            bottomPrint(%client, "<color:8BBD03>\- Entrance Force Field Compromised -", 2, 2);
         }
      }
   }
}

//----------------------------------------------------------------------------------------------- Generator::onEnabled ---

function Generator::onEnabled(%data, %obj, %prevState)
{
   Parent::onEnabled(%data, %obj, %prevState);
	
   //if the reserve generator was restored
   if (%obj == nameToId("ReserveGenerator"))
   {		
      %count = ClientGroup.getCount();
      for (%i = 0; %i < %count; %i++)
      {
         %client = ClientGroup.getObject(%i);
         if( %client.team == %obj.team )
            bottomPrint(%client, "<color:8BBD03>\- Reserve Generator Restored -", 5, 2);
         else if (%client.team == Game.offenseTeam)
            bottomPrint(%client, "<color:FF0000>\- Reserve Generator Restored -", 5, 2);
      }

      //return so no other bottom prints display
      return;
   }

   if (%obj == nameToId("MainGen1") || %obj ==  nameToId("MainGen1"))
   {
      if (nameToId("MainBase").powerCount < 2)
      {
      
         //if the switch generator was destroyed	
         %count = ClientGroup.getCount();
         for (%i = 0; %i < %count; %i++)
         {
            %client = ClientGroup.getObject(%i);
            if( %client.team == %obj.team )
            {
               //messageClient(%client, 'MsgClient', '~wfx/powered/base_power_on.wav');
               bottomPrint(%client, "<color:00BD8B>\- Main Gens Restored: Primary Spawnspheres Reactivated -", 3, 2);
            }
            else if (%client.team == Game.offenseTeam)
            {
               //messageClient(%client, 'MsgClient', '~wfx/Bonuses/Nouns/major.wav');
               bottomPrint(%client, "<color:FF0000>\- Main Gens Restored -", 3, 2);
            }
         }

         //set the custom spawn weights
         nameToId("MainBaseSpawn1").sphereWeight = 100;
         nameToId("MainBaseSpawn2").sphereWeight = 100;
         nameToId("MainBaseSpawn3").sphereWeight = 100;

         error("Generator::onEnabled - MainBase generators was restored");

         //return so no other bottom prints display
         return;
      }
   }

   //entrance solar panels
   if (%obj == nameToId("NorthEntranceSP") && nameToId("ReserveGroup").powerCount > 0)
   {
      %count = ClientGroup.getCount();
      for (%i = 0; %i < %count; %i++)
      {
         %client = ClientGroup.getObject(%i);
         if( %client.team == %obj.team )
            bottomPrint(%client, "<color:8BBD03>\Entrance Force Field Restored", 3, 2);
         else if (%client.team == Game.offenseTeam)
            bottomPrint(%client, "<color:FF0000>\Entrance Force Field Restored", 3, 2);
      }
   }
   if (%obj == nameToId("EastEntranceSP") && nameToId("ReserveGroup").powerCount > 0)
   {
      %count = ClientGroup.getCount();
      for (%i = 0; %i < %count; %i++)
      {
         %client = ClientGroup.getObject(%i);
         if( %client.team == %obj.team )
            bottomPrint(%client, "<color:8BBD03>\Entrance Force Field Restored", 3, 2);
         else if (%client.team == Game.offenseTeam)
            bottomPrint(%client, "<color:FF0000>\Entrance Force Field Restored", 3, 2);
      }
   }
   if (%obj == nameToId("WestEntranceSP") && nameToId("ReserveGroup").powerCount > 0)
   {
      %count = ClientGroup.getCount();
      for (%i = 0; %i < %count; %i++)
      {
         %client = ClientGroup.getObject(%i);
         if( %client.team == %obj.team )
            bottomPrint(%client, "<color:8BBD03>\Entrance Force Field Restored", 3, 2);
         else if (%client.team == Game.offenseTeam)
            bottomPrint(%client, "<color:FF0000>\Entrance Force Field Restored", 3, 2);
      }
   }
}

//------------------------------------------------------------------------------------------------ SiegeGame::halftime ---

function SiegeGame::halftime(%game, %reason)
{
   //reset the custom spawn weights
   nameToId("MainBaseSpawn1").sphereWeight = 100;
   nameToId("MainBaseSpawn2").sphereWeight = 100;
   nameToId("MainBaseSpawn3").sphereWeight = 100;

   Parent::halftime(%game, %reason);

   //clear bottom print messages
   clearBottomPrintAll();

   error("SiegeGame::halftime - clear Bottom Print Messages / Reset Spawnspheres");
}

//-------------------------------------------------------------------------------------------- SiegeGame::halftimeOver ---

function SiegeGame::halftimeOver( %game )
{
   // drop all players into mission
   %game.dropPlayers();

   //setup the AI for the second half
   %game.aiHalfTime();
   
   // start the mission again (release players)
   %game.halfTimeCountDown( 0 );

   //redo the objective waypoints
   %game.findObjectiveWaypoints();

   //set up ai vehicle functions for second half - Lagg... 10-2-2003   
   SweepForPads(NameToID(MissionGroup));
}

//----------------------------------------------------------------------------------- SiegeGame::objectSwapVehiclePads ---

function SiegeGame::objectSwapVehiclePads(%game, %this)
{
   %defTeam = %game.offenseTeam == 1 ? 2 : 1;

   if(%this.getDatablock().getName() $= "StationVehicle")
   {
      if(%this.getTarget() != -1)
      {
         // swap the teams of both the vehicle pad and the vehicle station
         if(getTargetSensorGroup(%this.getTarget()) == %game.offenseTeam)
         {
            setTargetSensorGroup(%this.getTarget(), %defTeam);
            %this.team = %defTeam;
            setTargetSensorGroup(%this.pad.getTarget(), %defTeam);
            %this.pad.team = %defTeam;
            // z0dd - ZOD, 4/20/02. Switch the teleporter too.
            setTargetSensorGroup(%this.teleporter.getTarget(), %defTeam);
            %this.teleporter.team = %defTeam;
         }
         else if(getTargetSensorGroup(%this.getTarget()) == %defTeam)
         {
            setTargetSensorGroup(%this.getTarget(), %game.offenseTeam);
            %this.team = %game.offenseTeam;
            setTargetSensorGroup(%this.pad.getTarget(), %game.offenseTeam);
            %this.pad.team = %game.offenseTeam;
            // z0dd - ZOD, 4/20/02. Switch the teleporter too.
            setTargetSensorGroup(%this.teleporter.getTarget(), %game.offenseTeam);
            %this.teleporter.team = %game.offenseTeam;
         }
      }
   }
}

//---------------------------------------------------------------------------------------- SiegeGame::vehicleDestroyed ---

//siege game spam fix
function SiegeGame::vehicleDestroyed(%game, %vehicle, %destroyer)
{
  //needed to prevent Siege Game consol spam - Lagg... 11-12-2003   
}

//-------------------------------------------------------------------------------------- StaticShapeData::damageObject ---

function StaticShapeData::damageObject(%data, %targetObject, %sourceObject, %position, %amount, %damageType)
{
   //base items are invincible on offensive team, send a message to all who try
   if (%targetObject == nameToId("StageSensor") || %targetObject == nameToId("PortTurret")
     || %targetObject == nameToId("StarboardTurret") || %targetObject == nameToId("StageInventory1")
     || %targetObject == nameToId("StageInventory2") || %targetObject == nameToId("StageInventory3")
     || %targetObject == nameToId("StageInventory4") || %targetObject == nameToId("StageSentry1")
     || %targetObject == nameToId("StageSentry2") || %targetObject == nameToId("StageSentry3")
     || (%data.noDamageInSiege && Game.class $= "SiegeGame"))
   {
      if(%sourceObject && %targetObject.isEnabled())
      {
         //if a player
         if(%sourceObject.client)
            messageClient(%sourceObject.client, 0, "\c5Offensive Base Equipment Invincible.~wfx/powered/station_denied.wav");
         //a shrike
         else if (%sourceObject.getDataBlock().catagory $= "Vehicles")
         {
            if(%sourceObject.getDatablock().numMountPoints > 0)
            {
               for(%i = 0; %i < %sourceObject.getDatablock().numMountPoints; %i++)
               {
                  if (%sourceObject.getMountNodeObject(%i) > 0)
                     messageClient( %sourceObject.getMountNodeObject(%i).client, 0, "\c5Offensive Base Equipment Invincible.~wfx/powered/station_denied.wav");
               }
            }
         }
         //or a bomber
         else if(%sourceObject.getDataBlock().getName() $= "BomberTurret")
         {
            %veh = %sourceObject.vehicleMounted;
            if(%veh.getDatablock().numMountPoints > 0)
            {
               for(%i = 0; %i < %veh.getDatablock().numMountPoints; %i++)
               {
                  if (%veh.getMountNodeObject(%i) > 0)
                     messageClient( %veh.getMountNodeObject(%i).client, 0, "\c5Offensive Base Equipment Invincible.~wfx/powered/station_denied.wav");
               }
            }
         }  
      }

      return;
   }

   Parent::damageObject(%data, %targetObject, %sourceObject, %position, %amount, %damageType);
}

//---------------------------------------------------------------------------------------------- end Fumarole_Siege package ---***---
};




