//----------------------------------------------- Custom ForceField Stuff ------------------------------------------------
//------------------------------------------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------------ ForceFieldBareData::onAdd ---

function ForceFieldBareData::onAdd(%data, %obj)
{
   Parent::onAdd(%data, %obj);

   %velo = 0.1;
   %grav = 1.0;
   %appl = "0 0 0";

   if(%obj.custom $= "1")
   {
      %velo = %obj.velocityMod;
      %grav = %obj.gravityMod;
      %appl = %obj.appliedForce;
   }   

   %pz = new PhysicalZone() {
      position = %obj.position;
      rotation = %obj.rotation;
      scale    = %obj.scale;
      polyhedron = "0.000000 1.0000000 0.0000000 1.0000000 0.0000000 0.0000000 0.0000000 -1.0000000 0.0000000 0.0000000 0.0000000 1.0000000";
      velocityMod  = %velo;
      gravityMod   = %grav;
      appliedForce = %appl;
		ffield = %obj;
   };

   %pzGroup = nameToID("MissionCleanup/PZones");
   if(%pzGroup <= 0)
   {
      %pzGroup = new SimGroup("PZones");
      MissionCleanup.add(%pzGroup);
   }
   %pzGroup.add(%pz);
}

//------------------------------------------------------ AI ZONE STUFF ---------------------------------------------------
//------------------------------------------------------------------------------------------------------------------------

//--------------------------------------------------- Outside Zone ---------------------------------------------
datablock TriggerData(outsideTrigger)
{
   tickPeriodMS = 50;
};

function outsideTrigger::onEnterTrigger(%data, %obj, %colObj)
{
   //set a tag on the client when he touches this trigger
   if (%colObj.client.isAIControlled() && %colObj.client.team == game.offenseTeam)
      %colObj.client.inBase = false;
}

function outsideTrigger::onLeaveTrigger(%data, %obj, %colObj)
{
   // do nothing
}

function outsideTrigger::onTickTrigger(%data, %obj)
{
  // do nothing
}

//--------------------------------------------------- Inside Zone ----------------------------------------------
datablock TriggerData(insideTrigger)
{
   tickPeriodMS = 50;
};

function insideTrigger::onEnterTrigger(%data, %obj, %colObj)
{
   //set a tag on the client when he touches this trigger
   if (%colObj.client.isAIControlled() && %colObj.client.team == game.offenseTeam)
      %colObj.client.inBase = true;
}

function insideTrigger::onLeaveTrigger(%data, %obj, %colObj)
{
   // do nothing
}

function insideTrigger::onTickTrigger(%data, %obj)
{
  // do nothing
}